--[[
**************************************************************************
*     Module de collect de donnes LO200 pour SIOC                       *
*     Par KaTZe     -         http://www.3rd-wing.net                    *
*     Version 2.0.4  du   06/04/2010                                     *
**************************************************************************
--]]

dofile ("./Config/Export/SIOC-Export/siocConfig.lua")

DEBUG_MODE = false; 	-- fichier ..\Lock On\Temp\KTZ-DataCollect.log
Data_Buffer = {}

-- logData("---KaTZe Log: KTZ-Data-Collect Activated ----")


------------------------------------------------------------------------
-- 	Login to SIOC													  --
------------------------------------------------------------------------

	package.path  = package.path..";.\\LuaSocket\\?.lua"
    package.cpath = package.cpath..";.\\LuaSocket\\?.dll"
    socket = require("socket")
    
    -- Change to correct ip and port (127.0.0.1 = localhost, 8092 = default SIOC port)
    -- host = "localhost"
    -- port = 8080
 
 -- Modif va chercher la config IP dans siocConfig
    host = siocConfig.hostIP or "127.0.0.1"
    port = siocConfig.hostPort or 8092
    c = socket.try(socket.connect(host, port)) -- connect to the listener socket
    c:setoption("tcp-nodelay",true) -- set immediate transmission mode
    c:settimeout(.01) -- set the timeout for reading the socket 
   
------------------------------------------------------------------------
-- 	Offset de SIOC qui seront couts								  --
-- 	0001 = Commande gnrale										  --
-- 	0002 = Commande spciale										  --
------------------------------------------------------------------------

	inputsTable = {}
	inputsTable [1]=1
	inputsTable [2]=2
	
	local lSIOC_Var, i
    local lSIOC_SendString = ""
    
    -- Generate the init string to SIOC (to register with SIOC which parameters we are interested in)
    for lSIOC_Var,i in pairs(inputsTable)
    do
        lSIOC_SendString = lSIOC_SendString..lSIOC_Var..":"
    end
	
    -- Send the initstring
    socket.try(c:send("Arn.Inicio:"..lSIOC_SendString.."\n"))
   
------------------------------------------------------------------------
-- 	Send Data to SIOC												  --
------------------------------------------------------------------------
function envoyerInfo(strAttribut,valeur)
	
		local strValeur = string.format("%d",valeur);
		if (strValeur ~= Data_Buffer[strAttribut]) then
			-- On stock la nouvelle valeur dans la table buffer
			Data_Buffer[strAttribut] = strValeur ;
			-- Envoi de la nouvelle valeur
			socket.try(c:send(string.format("Arn.Resp:%s=%.0f:\n",strAttribut,strValeur)))
		end
		
	end


------------------------------------------------------------------------
-- 	Get Data from SIOC												  --
------------------------------------------------------------------------	
function recupInfo()
	
	-- Check for data/string from the SIOC server on the socket
    -- logData("*** Fonction recupInfo activated","\n")

	local messageRecu = c:receive()
    
	if messageRecu then
		logData(" ", "\n")		
		logData("---Log: Data recu de SIOC-----", "\n")
		
		local s,l,typeMessage = string.find(messageRecu,"(Arn.%w+)");
		typeMessage = tostring(typeMessage);
        
		------------------------------------------------------------
		-- Les types de message accepts :                        --
		--                                                        --
		-- Arn.Vivo   : Le serveur  reu "Arn.Vivo": du client   -- implementation  tester
		--              Le serveur rpond "Arn.Vivo"              --
		--														  --
		-- Arn.Resp   : Message pour l'execution des commandes    -- rponse de SIOC
		--              seul deux valeurs sont acceptes:         --
		--				0=[valeur] -> le paramtres valeur(      )--
		-- 				1=[valeur] -> le paramtre commande		  --
		--				Ex:Arn.Resp:0=5000:1=3: ou Arn.Resp:1=145:--
		--              a noter que Arn.Resp:1=0: remets le       --
		--              cache valeur  'nil' aussi aprs chaque   --
		--				commande excut                          --
		------------------------------------------------------------
		if typeMessage == "Arn.Resp" then
			logData("Message type Arn.Resp-----", "\n")
			--------------------------------------------------------
			-- Type = Arn.Resp:                                   --
			--------------------------------------------------------
			
			-- extraction du message 
			-- (message type par exemple :1=3:0=23:6=3456)
			local debut,fin,message = string.find(messageRecu,"([%d:=-]+)")
			logData(message)
			-- longueur du message
			local longueur
			longueur = fin - debut
			-- logData(longueur)
			-- dcoupe du message en commande et envoi  lockon
			-- (commandes type 1=3  0=23  6=3456)
			
			local commande,Schan,chan,Svaleur,valeur,i,a,b,c,d,e,f,lim
			lim = 0

			while lim < longueur do
				a,b,commande = string.find(message,"([%d=-]+)", lim)
				logData(commande)
				c,d,Schan = string.find(commande, "([%d-]+)")
				chan = tonumber(Schan)
				logData(string.format(" Offset = %.0f",chan,"\n"))
				e,f,Svaleur = string.find(commande, "([%d-]+)",d+1)
				valeur = tonumber(Svaleur)
				logData(string.format(" Valeur = %.0f",valeur,"\n"))
				
				if chan ==1 and valeur > 0 then
						
					-- Envoi  LockOn
					LoSetCommand(valeur)
				
				end
								
				lim = b + 1
			end
			
		else
			logData("---Log: SIOC Message Incorrect ; non type Arn.Resp ; Message Ignor -----", "\n")
		end
    end
end







------------------------------------------------------------------------
-- 	Export de LockOn												  --
------------------------------------------------------------------------
function recupereInfosLockon_1()
	    -- Export  la 200ms
								
		envoyerInfo("22",LoGetIndicatedAirSpeed()*100)--ok
		envoyerInfo("23",LoGetTrueAirSpeed()*100)--ok
		envoyerInfo("24",LoGetAltitudeAboveSeaLevel()*100)
		envoyerInfo("25",LoGetAltitudeAboveGroundLevel()*100)
		envoyerInfo("26",LoGetAngleOfAttack()*5732)	-- Modif LockOn 2.0 valeur en radian (et plus en degrs)
		-- envoyerInfo("27",LoGetAccelerationUnits()*100) -- Modif LockOn 2.0 valeur xyz ...  calculer
		envoyerInfo("28",LoGetVerticalVelocity()*100)
		envoyerInfo("29",LoGetMachNumber()*10)--ok

		
		-- *****************************
		pitch,bank,yaw = LoGetADIPitchBankYaw()
		envoyerInfo("30",pitch*100)--ok
		envoyerInfo("31",bank*100)--ok
		envoyerInfo("32",yaw*100)--ok
		envoyerInfo("33",LoGetMagneticYaw()*100)
		envoyerInfo("34",LoGetGlideDeviation()*100)
		envoyerInfo("35",LoGetSideDeviation()*100)
		envoyerInfo("36",LoGetSlipBallPosition()*100)

		-- *****************************
		_LoGetControlPanel_HSI = LoGetControlPanel_HSI()
		envoyerInfo("38",_LoGetControlPanel_HSI.ADF*100)
		envoyerInfo("39",_LoGetControlPanel_HSI.RMI*100)
		envoyerInfo("40",_LoGetControlPanel_HSI.Compass*100)
		-- *****************************
		_LoGetEngineInfo=LoGetEngineInfo()
		envoyerInfo("41",_LoGetEngineInfo.RPM.left*10)--ok
		envoyerInfo("42",_LoGetEngineInfo.RPM.right*10)--ok
		envoyerInfo("43",_LoGetEngineInfo.Temperature.left*10)--ok
		envoyerInfo("44",_LoGetEngineInfo.Temperature.right*10)--ok
		envoyerInfo("45",_LoGetEngineInfo.HydraulicPressure.left*10)--ok
		envoyerInfo("46",_LoGetEngineInfo.HydraulicPressure.right*10)--ok
		
		
		
				
		local myXCoord, myZCoord
		if LoGetPlayerPlaneId() then
			local objPlayer = LoGetObjectById(LoGetPlayerPlaneId())
			myXCoord, myZCoord = getXYCoords(objPlayer.LatLongAlt.Lat, objPlayer.LatLongAlt.Long)
			-- envoyerInfo("12",objPlayer.Type)--ok
			-- Objets subtype :
			--	Airplane = 1, Helicopter = 2, Moving = 8, Standing = 9, Tank = 17, SAM	= 16,
 			--	Ship = 12, Missile = 4, Bomb = 5, Shell = 6, Rocket = 7, Airdrome = 13
			-- envoyerInfo("13",objPlayer.Subtype)--ok
			-- envoyerInfo("14",obj.Country)
			-- envoyerInfo("15",_Coalition[objPlayer.Coalition])
			envoyerInfo("16",myXCoord*100)--ok
			envoyerInfo("17",myZCoord*100)--ok
			envoyerInfo("18",objPlayer.LatLongAlt.Lat*100)--ok
			envoyerInfo("19",objPlayer.LatLongAlt.Long*100)--ok
			envoyerInfo("20",objPlayer.LatLongAlt.Alt*100)--ok
			envoyerInfo("21",objPlayer.Heading*100)--ok
		end
		
		local _LoGetRoute = LoGetRoute()
		if _LoGetRoute then
		local distance = math.sqrt(math.pow(_LoGetRoute.goto_point.world_point.x-myXCoord,2)+math.pow(_LoGetRoute.goto_point.world_point.z-myZCoord,2))
			envoyerInfo("55",distance);
			--envoyerInfo("49",_LoGetRoute.goto_point.this_point_num+1); -- 10/05/2008
			envoyerInfo("50",_LoGetRoute.goto_point.world_point.x*100); -- 10/05/2008
			--envoyerInfo("51",_LoGetRoute.goto_point.world_point.y*100); --10/05/2008
			--envoyerInfo("52",_LoGetRoute.goto_point.world_point.z*100); -- 10/05/2008
			--envoyerInfo("53",_LoGetRoute.goto_point.speed_req)
			envoyerInfo("54",_LoGetRoute.goto_point.estimated_time)
			--envoyerInfo("55",_LoGetRoute.goto_point.next_point_num)
			--envoyerInfo("56",table.getn(_LoGetRoute.route))
		end	


		-- *************************
		_LoGetTWSInfo = LoGetTWSInfo()
		--logData("TWS Export ", "\n")	
		--logData(_LoGetTWSInfo.mode)
		
		if _LoGetTWSInfo.mode then
		--LogData("TWS Mode ", "\n")	
		--logData(string.format(" TWS Mode = %.0f",_LoGetTWSInfo.mode,"\n"))
		--logData(string.format(" TWS Emmiters = %.0f",table.getn(_LoGetTWSInfo.Emitters),"\n"))
		--local _SignalType ={scan=0,lock=1,missile_radio_guided=2,track_while_scan=3}
		end
	
		if _LoGetTWSInfo then
		--logData("TWS Dtail ", "\n")
		for k,v in pairs(_LoGetTWSInfo.Emitters) do
			    local objEmitters = LoGetObjectById(v.ID)
					--logData(string.format(" Mission Time = %.0f secondes",CurrentTime,"\n"))
					--logData(string.format(" Emmiters en cours = %.0f",k,"\n"))
					-- logData(string.format(" Emmiters type = %.0f",objEmitters.Type,"\n"))
					--logData(v.SignalType)			
					--logData(string.format(" Emmiters power = %.0f",v.Power*1000,"\n"))
					--logData(string.format(" Emmiters azimuth = %.0f",v.Azimuth*1000,"\n"))
					--logData(string.format(" Emmiters priority = %.0f",v.Priority*1000,"\n"))

					envoyerInfo(596+5*k,k)
					envoyerInfo(597+5*k,v.Power*1000)
					envoyerInfo(598+5*k,v.Azimuth*1000)
					envoyerInfo(599+5*k,v.Priority*1000)
		end
		end
					
		--[[
		local _SignalType ={scan=0,lock=0,missile_radio_guided=0,track_while_scan=0}
		local _SignalTypeValeur ={scan=0,lock=1,missile_radio_guided=2,track_while_scan=3}
		local _SignalTypeCode = 0;
		self.envoyerInfo("162",_LoGetTWSInfo.Mode) -- (0 - all|1 - lock only|2 - launch only)
		self.envoyerInfo("163",table.getn(_LoGetTWSInfo.Emitters)) --  
  		for k,v in pairs(_LoGetTWSInfo.Emitters) do
 			if self.specialInfos[3]==k then -- 10/05/2008
			    local objEmitters = LoGetObjectById(v.ID)
				local EmitterXCoord,EmitterZCoord = self.getXYCoords(objEmitters.LatLongAlt.Lat, objEmitters.LatLongAlt.Long)
				self.envoyerInfo("180",k); -- Emitter en cours
				self.envoyerInfo("164",objEmitters.Type)
				-- Objets subtype :
				--	Airplane = 1, Helicopter = 2, Moving = 8, Standing = 9, Tank = 17, SAM	= 16,
	 			--	Ship = 12, Missile = 4, Bomb = 5, Shell = 6, Rocket = 7, Airdrome = 13
				self.envoyerInfo("165",objEmitters.Subtype)
				--self.envoyerInfo("166",obj.Country)
				self.envoyerInfo("167",_Coalition[objEmitters.Coalition])
				self.envoyerInfo("168",EmitterXCoord*100)
				self.envoyerInfo("169",EmitterZCoord*100)
				self.envoyerInfo("170",objEmitters.LatLongAlt.Lat*100)
				self.envoyerInfo("171",objEmitters.LatLongAlt.Long*100)
				self.envoyerInfo("172",objEmitters.LatLongAlt.Alt*100)
				self.envoyerInfo("173",objEmitters.Heading*100)
				self.envoyerInfo("174",v.ID)
				self.envoyerInfo("175",tonumber(v.Type.level1..v.Type.level2..v.Type.level3..v.Type.level4))
				self.envoyerInfo("176",v.Power*1000)
				self.envoyerInfo("177",v.Azimuth*1000)
				self.envoyerInfo("178",v.Priority)
				self.envoyerInfo("179",_SignalType[v.SignalType])

			end
			
			if _SignalType[v.SignalType]==0 then
				_SignalType[v.SignalType] = 1;
				_SignalTypeCode = _SignalTypeCode + math.pow(2, _SignalTypeValeur[v.SignalType])
			end
		--]]




		
	end	

function recupereInfosLockon_2()
	-- logData ("time de la boucle 2")
	-- logData(CurrentTime)
	
		-- Export  la seconde
		envoyerInfo("10",LoGetModelTime())--ok
		envoyerInfo("11",LoGetMissionStartTime())--ok
		
		envoyerInfo("37",LoGetBasicAtmospherePressure())
		
		envoyerInfo("47",_LoGetEngineInfo.fuel_internal*100)--ok
		envoyerInfo("48",_LoGetEngineInfo.fuel_external*100)--ok 
		
		
		envoyerInfo("416",_LoGetEngineInfo.FuelConsumption.left*6) --conversion kg/10sec (erreur ds LO200) en kg/mn
		envoyerInfo("417",_LoGetEngineInfo.FuelConsumption.right*6) --conversion kg/10sec (erreur ds LO200) en kg/mn
		envoyerInfo("418",(_LoGetEngineInfo.FuelConsumption.left + _LoGetEngineInfo.FuelConsumption.right)*6)
		
		-- Export des lments mcaniques
		_LoGetMechInfo = LoGetMechInfo()
		Gear_Main = _LoGetMechInfo.gear.main
		
		-- logData(Gear_Main.left.rod)

		envoyerInfo("1201",_LoGetMechInfo.canopy.status)
		envoyerInfo("1202",_LoGetMechInfo.canopy.value)
		envoyerInfo("1203",_LoGetMechInfo.wheelbrakes.status)	
		envoyerInfo("1204",_LoGetMechInfo.wheelbrakes.value)
		envoyerInfo("1205",_LoGetMechInfo.flaps.status)	
		envoyerInfo("1206",_LoGetMechInfo.flaps.value)	
		envoyerInfo("1207",_LoGetMechInfo.speedbrakes.status)
		envoyerInfo("1208",_LoGetMechInfo.speedbrakes.value)	
		envoyerInfo("1209",_LoGetMechInfo.parachute.status)	
		envoyerInfo("1210",_LoGetMechInfo.parachute.value)			
		
		envoyerInfo("1211",_LoGetMechInfo.gear.status)
		envoyerInfo("1212",_LoGetMechInfo.gear.value)
		--envoyerInfo("1213",_LoGetMechInfo.gear.main.nose.rod)		
		--envoyerInfo("1214",_LoGetMechInfo.gear.main.left.rod)
		--envoyerInfo("1215",_LoGetMechInfo.gear.main.right.rod)
		-- envoyerInfo("1215",Gear_Main.left.rod)
		
		
		
		local _LoGetPayloadInfo = LoGetPayloadInfo()
						
		local pylone_selec = _LoGetPayloadInfo.CurrentStation  -- Pylone selectionn
		local quantite_selec = 0
		local type_arme_selec = 0

		
		if pylon_selec~= 0 then
				if _LoGetPayloadInfo.Stations[pylone_selec]~= nil then 
					type_arme_selec = _LoGetPayloadInfo.Stations[pylone_selec].weapon
					local type_arme_num_selec = tonumber(type_arme_selec.level1..type_arme_selec.level2..type_arme_selec.level3..type_arme_selec.level4)
					quantite_selec = _LoGetPayloadInfo.Stations[pylone_selec].count
					-- logData(type_arme_selec.level1)
					-- logData(type_arme_selec.level2)
					-- logData(type_arme_selec.level3)
					-- logData(type_arme_selec.level4)
					envoyerInfo(100,pylone_selec)
					envoyerInfo(182,pylone_selec)
					envoyerInfo(101,quantite_selec)
					envoyerInfo(184,quantite_selec)
					envoyerInfo(102,type_arme_num_selec)			
					envoyerInfo(183,type_arme_num_selec)
				end
		end
		
		local canon = _LoGetPayloadInfo.Cannon.shells  -- Nombre de munitions canon restantes
		envoyerInfo(105,canon)
		
		local pylone
		local quantite
		local type_arme
		local type_arme_num
		
		-- Scan du panel armement et envoi  SIOC
		for pylone=1,13 do
			if _LoGetPayloadInfo.Stations[pylone]~=nil then
				quantite = _LoGetPayloadInfo.Stations[pylone].count
				type_arme = _LoGetPayloadInfo.Stations[pylone].weapon
				type_arme_num = tonumber(type_arme.level1..type_arme.level2..type_arme.level3..type_arme.level4)
				
				if _LoGetPayloadInfo.Stations[pylone].container then
					envoyerInfo(150+pylone,1)
				else
					envoyerInfo(150+pylone,0)
				end
		
				envoyerInfo(110+pylone,quantite)
				envoyerInfo(540+pylone,quantite) --Specific KaTZ-Pit
				envoyerInfo(130+pylone,type_arme_num)
				envoyerInfo(520+pylone,type_arme_num) --Specific KaTZ-Pit
				
			end
			
		end

		
		-- Module de Navigation
		local _LoGetNavigationInfo = LoGetNavigationInfo()
		if _LoGetNavigationInfo then
			local _strMaster = _LoGetNavigationInfo.SystemMode.master
			local _strSubmode = _LoGetNavigationInfo.SystemMode.submode
			local _strACS = _LoGetNavigationInfo.ACS.mode
			
			--logData(_strMaster)
			--logData(_strSubmode)
			--logData(_strACS)
			
			-- Modes de Navigation, Combat
			local _tabMaster = {
							NAV=1, BVR=2, CAC=3, LNG=6, A2G=7, OFF=9  
							}
							
			local _numMaster = _tabMaster[_strMaster]
			--logData(_numMaster)
			
			-- Modes de Navigation, Combat			
			local _tabSubmode = {
							ROUTE=11, ARRIVAL=12, LANDING=13, GUN=21, RWS=22, TWS=23, STT=24, VERTICAL_SCAN=33, BORE=34, HELMET=35, FLOOD=61, UNGUIDED=71, PINPOINT=72, ETS=73, OFF=99
							}
			local _numSubmode = _tabSubmode[_strSubmode]
			--logData(_numSubmode)				

			-- Modes de PilotAuto			
			local _tabACS = {
							FOLLOW_ROUTE=1, BARO_HOLD=2, RADIO_HOLD=3, BARO_ROLL_HOLD=4, HORIZON_HOLD=5, PITCH_BANK_HOLD=6, OFF=9
							}
			local _numACS = _tabACS[_strACS]
			--logData(_numACS)		
			
			envoyerInfo(60,_numMaster)
			envoyerInfo(61,_numSubmode)
			envoyerInfo(62,_numACS)
			-- Automanette			
			envoyerInfo(63,_LoGetNavigationInfo.ACS.autothrust and 1 or 0)
		end

		
				
		
--  Old MPC  modifier		-- MPC State *******************************
		_LoGetMCPState = LoGetMCPState()
		local _compteur = 0
		local _MCPState = 0
		for n,v in pairs(_LoGetMCPState) do
			if (v) then
			
				_MCPState = _MCPState + math.pow(2,_compteur)
			end
			_compteur = _compteur + 1
		end
		envoyerInfo("71",_MCPState) -- Voir dtails dans notice
			
	end

	
	-- Mise  zero initiale du panel armement
function WeaponInit()
		local pylone
		logData(" Mise  zero du panel armement")
						
		for pylone=1,13 do
				envoyerInfo(110+pylone,0)
				envoyerInfo(130+pylone,0)
		end
end			
	
	
	------------------------------------------------------------------------
	--    Fonction pour le calcul des coordonnes 						  --
	--	  Merci  Mnemonic                           					  --
	------------------------------------------------------------------------
	getXYCoords = function(inLatitudeDegrees, inLongitudeDegrees) -- args: 2 numbers // Return two value in order: X, Y
        local pi = 3.141592

		local zeroX = 5000000
		local zeroZ = 6600000

		local centerX = 11465000 - zeroX --circle center
		local centerZ =  6500000 - zeroZ

		local pnSxW_X = 4468608 - zeroX -- point 40dgN : 24dgE
		local pnSxW_Z = 5730893 - zeroZ

		local pnNxW_X = 5357858 - zeroX -- point 48dgN : 24dgE
		local pnNxW_Z = 5828649 - zeroZ

		local pnSxE_X = 4468608 - zeroX -- point 40dgN : 42dgE
		local pnSxE_Z = 7269106 - zeroZ

		local pnNxE_X = 5357858 - zeroX -- point 48dgN : 42dgE
		local pnNxE_Z = 7171350 - zeroZ

		local lenNorth = math.sqrt((pnNxW_X-centerX)*(pnNxW_X-centerX) + (pnNxW_Z-centerZ)*(pnNxW_Z-centerZ))
		local lenSouth = math.sqrt((pnSxW_X-centerX)*(pnSxW_X-centerX) + (pnSxW_Z-centerZ)*(pnSxW_Z-centerZ))
		local lenN_S = lenSouth - lenNorth

		local RealAngleMaxLongitude = math.atan ((pnSxW_Z - centerZ)/(pnSxW_X - centerX)) * 180/pi
		-- borders
		local EndWest = 24
		local EndEast = 42
		local EndNorth = 48
		local EndSouth = 40
		local MiddleLongitude = (EndWest + EndEast) / 2
		local ToLengthN_S = ((EndNorth - EndSouth) / lenN_S)
		local ToAngleW_E = (MiddleLongitude - EndWest) / RealAngleMaxLongitude

		local ToDegree = 360/(2*pi)
	    -- Lo coordinates system
	    local realAng = (inLongitudeDegrees - MiddleLongitude) / ToAngleW_E / ToDegree;
	    local realLen = lenSouth - (inLatitudeDegrees - EndSouth) / ToLengthN_S;
	    local outX = centerX - realLen * math.cos (realAng);
	    local outZ = centerZ + realLen * math.sin (realAng);
	    return outX, outZ
	end	


	
------------------------------------------------------------------------
-- 	Squenceur de tche												  --
------------------------------------------------------------------------
	
StartTime = LoGetMissionStartTime()
CurrentTime = LoGetModelTime()
SamplingPeriod_1 = 0.2
SamplingPeriod_2 = 1
NextSampleTime_1 = CurrentTime + SamplingPeriod_1
NextSampleTime_2 = CurrentTime + SamplingPeriod_2

KTZ_DATA =
{
-- Fonction au dmarrage mission


	KD_Start=function(self)
		logData("  ","\n")
		logData("*** Fonction KD_Start ***","\n")
		logData(string.format(" Mission Start Time = %.0f",StartTime,"\n"))	
		logData(string.format(" Sampling Period 1 = %.1f secondes",NextSampleTime_1,"\n"))
		logData(string.format(" Sampling Period 2 = %.1f secondes",NextSampleTime_2,"\n"))
		
		local name = LoGetPilotName()
		logData(name)
		logData("  ","\n")
		
		-- Mise  zero du panel armement dans SIOC
		WeaponInit()
			
		
	end,

-- Fonction avant chaque image	
	KD_BeforeNextFrame=function(self)
		-- logData(string.format("*** Fonction KD_BeforeNextFrame @= %.2f",CurrentTime,"\n"))
		recupInfo()
	end,
	
-- Fonction aprs chaque image
	KD_AfterNextFrame=function(self)
		CurrentTime = LoGetModelTime()
	end,

-- Fonction  chaque intervalle de temps type 1
	KD_AtInterval_1=function(self)
				
		-- logData(string.format("*** Fonction KD_AtInterval_1 @= %.2f",CurrentTime,"\n"))
		-- calcul de la date de fin du prochain intervalle de temps
		NextSampleTime_1 = CurrentTime + SamplingPeriod_1
	
		-- export des donnes LO200 , stockage dans table Data_Buffer , et envoi  SIOC
		recupereInfosLockon_1()
		recupInfo()
	
	end,

-- Fonction  chaque intervalle de temps type 1
	KD_AtInterval_2=function(self)
				
		-- logData(string.format("*** Fonction KD_AtInterval_2 @= %.2f",CurrentTime,"\n"))
		-- calcul de la date de fin du prochain intervalle de temps
		NextSampleTime_2 = CurrentTime + SamplingPeriod_2
	
		-- export des donnes LO200 , stockage dans table Data_Buffer , et envoi  SIOC
		recupereInfosLockon_2()
				
	end,	
	
-- Fonction fin de mission
	KD_Stop=function(self)
	
	logData("*** Fonction KD_Stop ***")
	logData("  ","\n")
		
	-- log des rsultats
	logData(string.format(" Flight Duration = %.0f secondes",CurrentTime,"\n"))
	logData("  ","\n")
	logData("  ","\n")
	logData("Miaou  tous !!!")
		
	end,
		
}


-- Declencheur de squence (depuis export.lua)
------------------------------------------------------------------------
--    Squence : Dmarrage de mission (ExportStart)    			  --
------------------------------------------------------------------------

do
	local PrevLuaExportStart=LuaExportStart;

	LuaExportStart=function()
		KTZ_DATA:KD_Start();
		
		if PrevLuaExportStart then
			PrevLuaExportStart();
		end
	end
end

------------------------------------------------------------------------
--    Squence : avant chaque image            							  --
------------------------------------------------------------------------

do
	local PrevLuaExportBeforeNextFrame=LuaExportBeforeNextFrame;

	LuaExportBeforeNextFrame=function()
		-- KTZ_DATA:KD_BeforeNextFrame();
						
		if PrevLuaExportBeforeNextFrame then
			PrevLuaExportBeforeNextFrame();
		end
	end
end

------------------------------------------------------------------------
--    Squence : aprs chaque image            							  --
------------------------------------------------------------------------

do
	local PrevLuaExportAfterNextFrame=LuaExportAfterNextFrame;

	LuaExportAfterNextFrame=function()
		KTZ_DATA:KD_AfterNextFrame();
			if CurrentTime >= NextSampleTime_1 then
				KTZ_DATA:KD_AtInterval_1();
			end
			if CurrentTime >= NextSampleTime_2 then
				KTZ_DATA:KD_AtInterval_2();
			end
			
		if PrevLuaExportAfterNextFrame then
			PrevLuaExportAfterNextFrame();
		end
	end
end


------------------------------------------------------------------------
--    Squence : Fin de mission (ExportStop)         				  --
------------------------------------------------------------------------

do
	local PrevLuaExportStop=LuaExportStop;

	LuaExportStop=function()
		KTZ_DATA:KD_Stop();

		if PrevLuaExportStop then
			PrevLuaExportStop();
		end
	end
end


------------------------------------------------------------------------
--    Fonction logData												  --
------------------------------------------------------------------------
function logData(message)
	if DEBUG_MODE and not fichierDataLog then
       	fichierDataLog = io.open("./Temp/KTZ-DataCollect-"..os.date("%Y%m%d-%H%M")..".txt.log", "w");
		if fichierDataLog then
			io.output(fichierDataLog);
			io.write("**************************************************************************\n");
			io.write("*     Fichier log du Data Collection pour SIOC                           *\n");
			io.write("*     Par KaTZe  -  http://www.3rd-wing.net                              *\n");
			io.write("*     Version 2.0.2 du 06/04/2010                                        *\n");
			io.write("**************************************************************************\n\n");
		end
    end
	if fichierDataLog then
		if message then
        io.write(string.format(" %s - %s",os.date("%d/%m/%y %H:%M:%S"),message),"\n");
		end
	end
end


